Loading...
Searching...
No Matches
CglFakeClique Class Reference

`#include <CglClique.hpp>`

Inheritance diagram for CglFakeClique:
[legend]
Collaboration diagram for CglFakeClique:
[legend]

## Public Member Functions

| CglFakeClique (const CglFakeClique &rhs)
| Copy constructor.
virtual CglCutGenerator * | clone () const
| Clone.
CglFakeClique & | operator= (const CglFakeClique &rhs)
| Assignment operator.
virtual void | generateCuts (const OsiSolverInterface &si, OsiCuts &cs, const CglTreeInfo info=CglTreeInfo())
| Generate cuts for the model data contained in si.
Public Member Functions inherited from CglClique
| CglClique (const CglClique &rhs)
| Copy constructor.
CglClique & | operator= (const CglClique &rhs)
| Assignment operator.
| CglClique (bool setPacking=false, bool justOriginalRows=false)
| Default constructor.
virtual | ~CglClique ()
| Destructor.
virtual std::string | generateCpp (FILE *fp)
| Create C++ lines to get to current state.
void | considerRows (const int numRows, const int *rowInd)
void | setStarCliqueNextNodeMethod (scl_next_node_method method)
void | setStarCliqueCandidateLengthThreshold (int maxlen)
void | setRowCliqueCandidateLengthThreshold (int maxlen)
void | setStarCliqueReport (bool yesno=true)
void | setRowCliqueReport (bool yesno=true)
void | setDoStarClique (bool yesno=true)
void | setDoRowClique (bool yesno=true)
void | setMinViolation (double minviol)
double | getMinViolation () const
void | setMaxNumber (int value)
| Maximum number of binaries for looking at all.
Public Member Functions inherited from CglCutGenerator
| CglCutGenerator ()
| Default constructor.
| CglCutGenerator (const CglCutGenerator &)
| Copy constructor.
CglCutGenerator & | operator= (const CglCutGenerator &rhs)
| Assignment operator.
virtual | ~CglCutGenerator ()
| Destructor.
virtual void | refreshSolver (OsiSolverInterface *)
| This can be used to refresh any information.
int | getAggressiveness () const
| Get Aggressiveness - 0 = neutral, 100 is normal root node.
void | setAggressiveness (int value)
| Set Aggressiveness - 0 = neutral, 100 is normal root node.
void | setGlobalCuts (bool trueOrFalse)
| Set whether can do global cuts.
bool | canDoGlobalCuts () const
| Say whether can do global cuts.
virtual bool | mayGenerateRowCutsInTree () const
| Returns true if may generate Row cuts in tree (rather than root node).
virtual bool | needsOptimalBasis () const
| Return true if needs optimal basis to do cuts.
virtual int | maximumLengthOfCutInTree () const
| Return maximum length of cut in tree.

## Constructors and destructors

OsiSolverInterface * | fakeSolver_
| fake solver to use
CglProbing * | probing_
| Probing object.
| CglFakeClique (OsiSolverInterface *solver=NULL, bool setPacking=false)
| Default constructor.
virtual | ~CglFakeClique ()
| Destructor.
void | assignSolver (OsiSolverInterface *fakeSolver)
| Assign solver (generator takes over ownership).

## Additional Inherited Members

Public Types inherited from CglClique
enum | scl_next_node_method { SCL_MIN_DEGREE , SCL_MAX_DEGREE , SCL_MAX_XJ_MAX_DEG }
| possible choices for selecting the next node in the star clique search More...
int | aggressive_
| Aggressiveness - 0 = neutral, 100 is normal root node.
bool | canDoGlobalCuts_
| True if can do global cuts i.e. no general integers.
Protected Attributes inherited from CglClique
const int * | cl_perm_indices
| variables/arrays that are used across many methods
int | cl_perm_length
| The length of cl_perm_indices.
int * | cl_indices
| List of indices that should be considered for extending the ones listed in cl_perm_indices.
int | cl_length
| The length of cl_indices.
int * | cl_del_indices
| An array of nodes discarded from the candidate list.
int | cl_del_length
| The length of cl_del_indices.
bool | setPacking_
| An indicator showing whether the whole matrix in the solverinterface is a set packing problem or not.
bool | justOriginalRows_
| True if just look at original rows.
int | sp_numrows
| pieces of the set packing part of the solverinterface
int * | sp_orig_row_ind
int | sp_numcols
int * | sp_orig_col_ind
double * | sp_colsol
int * | sp_col_start
int * | sp_col_ind
int * | sp_row_start
int * | sp_row_ind
frac_graph | fgraph
| the intersection graph corresponding to the set packing problem
bool * | node_node
| the node-node incidence matrix of the intersection graph.
double | petol
| The primal tolerance in the solverinterface.
int | maxNumber_
| Maximum number of binaries for looking at all.
bool | do_row_clique
| data for the star clique algorithm
bool | do_star_clique
| whether to do the star clique algorithm or not.
scl_next_node_method | scl_next_node_rule
| How the next node to be added to the star clique should be selected.
int | scl_candidate_length_threshold
| In the star clique method the maximal length of the candidate list (those nodes that are in a star, i.e., connected to the center of the star) to allow complete enumeration of maximal cliques.
bool | scl_report_result
| whether to give a detailed statistics on the star clique method
int | rcl_candidate_length_threshold
| In the row clique method the maximal length of the candidate list (those nodes that can extend the row clique, i.e., connected to all nodes in the row clique) to allow complete enumeration of maximal cliques.
bool | rcl_report_result
| whether to give a detailed statistics on the row clique method

## Detailed Description

Definition at line 266 of file CglClique.hpp.

## Constructor & Destructor Documentation

## CglFakeClique() [1/2]

CglFakeClique::CglFakeClique | ( | const CglFakeClique & | rhs | ) |

Copy constructor.

## CglFakeClique() [2/2]

CglFakeClique::CglFakeClique | ( | OsiSolverInterface * | solver = NULL,
|  | bool | setPacking = false )

Default constructor.

If the setPacking argument is set to true then CglFakeClique will assume that the problem in the solverinterface passed to the generateCuts() method describes a set packing problem, i.e.,

- all variables are binary
- the matrix is a 0-1 matrix
- all constraints are '= 1' or '<= 1'

Otherwise the user can use the considerRows() method to set the list of clique rows, that is,

- all coeffs corresponding to binary variables at fractional level is 1
- all other coeffs are non-negative
- the constraint is '= 1' or '<= 1'.

If the user does not set the list of clique rows then CglFakeClique will start the generateCuts() methods by scanning the matrix for them.

## ~CglFakeClique()

virtual CglFakeClique::~CglFakeClique | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## clone()

virtual CglCutGenerator * CglFakeClique::clone | ( |  | ) | const

virtual

Clone.

Reimplemented from CglClique.

## operator=()

CglFakeClique & CglFakeClique::operator= | ( | const CglFakeClique & | rhs | ) |

Assignment operator.

## generateCuts()

virtual void CglFakeClique::generateCuts | ( | const OsiSolverInterface & | si,
|  | OsiCuts & | cs,
|  | const CglTreeInfo | info = CglTreeInfo() )

virtual

Generate cuts for the model data contained in si.

The generated cuts are inserted into and returned in the collection of cuts cs.

Reimplemented from CglClique.

## assignSolver()

void CglFakeClique::assignSolver | ( | OsiSolverInterface * | fakeSolver | ) |

Assign solver (generator takes over ownership).

## Member Data Documentation

## fakeSolver_

OsiSolverInterface* CglFakeClique::fakeSolver_

protected

fake solver to use

Definition at line 307 of file CglClique.hpp.

## probing_

CglProbing* CglFakeClique::probing_

protected

Probing object.

Definition at line 309 of file CglClique.hpp.

The documentation for this class was generated from the following file:

- Cgl/src/CglClique/CglClique.hpp